package bicliqueviz;

import java.awt.Shape;
import org.apache.commons.collections15.Transformer;
import edu.uci.ics.jung.visualization.decorators.AbstractVertexShapeTransformer;

/**
 * 
 * Class for defining community shape and size
 * 
 * @author Martin Schwartz
 *
 */
public class CommunitySizeShape extends AbstractVertexShapeTransformer<VertexObj> implements Transformer<VertexObj,Shape>
{
	public static final float SCALER = 0.5f;

	public CommunitySizeShape() 
	{
		setSizeTransformer(new Transformer<VertexObj,Integer>()
				{
					public Integer transform(VertexObj v) 
					{
						return (int)(SCALER*(float)v.getNumOfNodes())+20;
					}
				});
	}
	
	public Shape transform(VertexObj v)
	{
		if(v.getShape() != null)
		{
			if(v.getShape().equalsIgnoreCase("SQUARE"))
			{
				return factory.getRectangle(v);
			}
			else if(v.getShape().equalsIgnoreCase("TRIANGLE"))
			{
				return factory.getRegularPolygon(v, 3);
			}
			else
			{
				return factory.getEllipse(v);
			}
		}
		else
		{
			return factory.getEllipse(v);
		}
	}

}
