package bicliqueviz;

import edu.uci.ics.jung.visualization.control.AbstractPopupGraphMousePlugin;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import edu.uci.ics.jung.visualization.VisualizationViewer;
import javax.swing.JPopupMenu;
import edu.uci.ics.jung.visualization.control.AbstractModalGraphMouse;

/**
 * 
 * This is a custom popup plugin made for a JUNG using some examples from JUNGs website
 * 
 * @author Martin Schwartz
 *
 */
public class CustomPopupPlugin2 extends AbstractPopupGraphMousePlugin implements MouseListener 
{    
    public CustomPopupPlugin2() 
    {
        this(MouseEvent.BUTTON3_MASK);
    }
    public CustomPopupPlugin2(int modifiers) 
    {
        super(modifiers);
    }
    
    /**
     * If this event is over a Vertex, pop up a menu to
     * allow the user to increase/decrease the voltage
     * attribute of this Vertex
     * @param e
     */
    @SuppressWarnings("unchecked")
    protected void handlePopup(MouseEvent e) 
    {
        final VisualizationViewer<Integer,Number> vv = 
            (VisualizationViewer<Integer,Number>)e.getSource();
        AbstractModalGraphMouse mouse = (AbstractModalGraphMouse)vv.getGraphMouse();
        
        JPopupMenu popup = new JPopupMenu();
        
        popup.add(mouse.getModeMenu());
        popup.show(vv, e.getX(), e.getY());
    }
}