package bicliqueviz;

import java.awt.Stroke;
import java.awt.BasicStroke;

import org.apache.commons.collections15.Transformer;

import edu.uci.ics.jung.visualization.picking.PickedState;

/**
 * 
 * Class for defining edge thickness in the graph
 * 
 * @author the1schwartz
 *
 */
public class EdgeStroke implements Transformer<EdgeObj,Stroke>
{
	private PickedState<EdgeObj> pi;
	private Stroke normal = new BasicStroke(1.0f);
	private Stroke thick = new BasicStroke(2.5f);

	/**
	 * @param p pointer to picked state of the graph
	 */
	public EdgeStroke(PickedState<EdgeObj> p) 
	{
		pi = p;
	}

	public Stroke transform(EdgeObj e)
	{
		if(pi.isPicked(e))
		{
			//return thick;
			return new BasicStroke(e.getThickness()+1.0f);
		}
		else
		{
			return new BasicStroke(e.getThickness());
		}
	}
}
