package bicliqueviz;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartFrame;
import org.jfree.chart.JFreeChart;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.chart.plot.PlotOrientation;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.JComboBox;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Hashtable;

public class HistogramDegWin implements ActionListener
{
	static final long serialVersionUID = 76222l;
	private DefaultCategoryDataset data;
	private DefaultMutableTreeNode root;
	private JComboBox combo;
	private ChartFrame frame;

	public HistogramDegWin(DefaultMutableTreeNode r) 
	{
		root = r;
		createChart();
	}
	
	private void createChart()
	{		
		//createCommList();
		data = createDataSet(0);
		
		JFreeChart chart = ChartFactory.createStackedBarChart("Node degree histogram", "Node degree", 
				"Number of nodes with that degree", data, PlotOrientation.VERTICAL, true, true, false);
		
		frame = new ChartFrame("Node degree histogram", chart);
		frame.setLayout(new BorderLayout());
		//frame.add(combo, BorderLayout.NORTH);
		frame.pack();
		frame.setVisible(true);
	}
	
	private DefaultCategoryDataset createDataSet(int index)
	{
		DefaultCategoryDataset d = new DefaultCategoryDataset();
		
		if(BiCliqueWin.select_file != null)
		{	
			Hashtable<Integer, Integer> a_degrees = new Hashtable<Integer, Integer>();
			Hashtable<Integer, Integer> b_degrees = new Hashtable<Integer, Integer>();
			ProgWin pw = new ProgWin();
			pw.setTextAreaHeader("Checking file format...");
			pw.setValue(0);
			pw.showWin(true);
			
			try 
			{
				File ff = new File(BiCliqueWin.select_file);
				double fileSize = ff.length();
				double bytesLeft = fileSize;
				BufferedReader reader = new BufferedReader(new FileReader(BiCliqueWin.select_file));
				
				String line = reader.readLine();
				bytesLeft -= line.getBytes().length+2;
				
				while(line != null)
				{
					String[] splitLine = line.split("\\s");
					int a = Integer.parseInt(splitLine[0]);
					int b = Integer.parseInt(splitLine[1]);
					
					if(!a_degrees.containsKey(a))
					{
						a_degrees.put(a, 1);
					}
					else
					{
						int size = a_degrees.remove(a);
						
						a_degrees.put(a, size+1);
					}
					
					if(!b_degrees.containsKey(b))
					{
						b_degrees.put(b, 1);
					}
					else
					{
						int size = b_degrees.remove(b);
						
						b_degrees.put(b, size+1);
					}
					
					line = reader.readLine();
					if(line != null)
					{
						bytesLeft -= line.getBytes().length+2;
					}
					
					if(bytesLeft > 0)
					{
						double progress = 100.0*(fileSize-bytesLeft)/fileSize;
						int p = Math.min((int)progress, 100);
						pw.setValue(p);
					}
					else
					{
						pw.setValue(100);
					}
				}
			}
			catch (FileNotFoundException e) 
			{
				e.printStackTrace();
			} 
			catch (IOException e) 
			{
				e.printStackTrace();
			}
			
			DefaultMutableTreeNode n = (DefaultMutableTreeNode)root.getChildAt(index);
			
			for(int j = 0; j < n.getChildCount(); j++)
			{
				DefaultMutableTreeNode nn = (DefaultMutableTreeNode)n.getChildAt(j);
				
				Community c = (Community)nn.getUserObject();
				
				d.addValue(c.getNumOfUpperNodes(), "Node A", c.getID()+"");
				d.addValue(c.getNumOfLowerNodes(), "Node B", c.getID()+"");
			}
		}
		
		return d;
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource().equals(combo))
		{
			/*data = createDataSet(combo.getSelectedIndex());
			JFreeChart chart = ChartFactory.createStackedBarChart("Community size histrogram", "Community ID", 
					"Community size", data, PlotOrientation.VERTICAL, true, true, false);
			frame.getChartPanel().setChart(chart);*/
		}
	}
}
