package bicliqueviz;

/**
 * 
 * Represents a pair of an vertex ID and vertex type (A or B)
 * 
 * @author Martin Schwartz
 *
 */
public class IDNodeTypePair 
{
	private int id;
	private boolean type;

	/**
	 * @param i id of vertex
	 * @param t type of vertex, true= vertex A type, false vertex B type
	 */
	public IDNodeTypePair(int i, boolean t) 
	{
		id = i;
		type = t;
	}

	/**
	 * @return id of vertex
	 */
	public int getID()
	{
		return id;
	}
	
	/**
	 * @return type of vertex
	 */
	public boolean getNodeType()
	{
		return type;
	}
	
	public int hashCode()
	{
		return toString().hashCode();
	}
	
	public boolean equals(Object o)
	{
		if(o.getClass().equals(IDNodeTypePair.class))
		{
			IDNodeTypePair n = (IDNodeTypePair)o;
			
			return n.getID() == id && n.getNodeType() == type;
		}
		else
		{
			return false;
		}
	}
	
	public String toString()
	{
		return "("+id+","+type+")";
	}
}
