package bicliqueviz;

import javax.swing.JMenuItem;
import com.centerkey.utils.BareBonesBrowserLaunch;

/**
 * 
 * Class representing menu items for pop up menu of type 
 * 
 * @author the1schwartz
 *
 */
public class ListPopupItem extends JMenuItem
{
	private final static long serialVersionUID = 177;
	private final String url;
	
	/**
	 * @param n name of menu item
	 * @param s url to link to
	 */
	public ListPopupItem(String n, String s) 
	{
		super(n);
		url = s;
	}

	/**
	 * 
	 * Opens website for given string
	 * 
	 * @param s string to use in url
	 */
	public void runWebSearch(String s)
	{
		s = s.replaceAll("\\s", "%20");
		String u = url.replace("{s}", s);
		BareBonesBrowserLaunch.openURL(u.trim());
	}
}
