package bicliqueviz;

import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;

import java.awt.BorderLayout;
import javax.swing.JButton;
import java.util.Vector;
import javax.swing.ListSelectionModel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * 
 * Window for search results
 * 
 * @author the1schwartz
 *
 */
public class SearchResultsCommWin extends JFrame implements ActionListener
{
	private final static long serialVersionUID = 547;
	private JList results;
	private JButton okButton;
	private BiCliqueWin win;

	/**
	 * @param r list of results to display
	 * @param w pointer to parent window
	 */
	public SearchResultsCommWin(Vector<Community> r, BiCliqueWin w) 
	{
		super("Search Results");
		win = w;
		setAlwaysOnTop(true);
		setResizable(false);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		setLocationRelativeTo(null);
		JPanel panel = new JPanel(new BorderLayout());
		results = new JList(r);
		results.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		results.setSelectedIndex(0);
		JScrollPane scroll = new JScrollPane(results);
		scroll.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		scroll.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		panel.add(scroll, BorderLayout.CENTER);
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		panel.add(okButton, BorderLayout.SOUTH);
		
		setContentPane(panel);
		pack();
		setVisible(true);
	}

	public void actionPerformed(ActionEvent ae)
	{
		if(results.getSelectedIndex() != -1)
		{
			win.selectCommunity((Community)results.getSelectedValue());
			dispose();
		}
	}
}
