package bicliqueviz;

import java.util.Vector;

import edu.uci.ics.jung.graph.UndirectedSparseGraph;
import edu.uci.ics.jung.graph.util.Pair;

/**
 * 
 * Class for item the vertex community list
 * 
 * @author the1schwartz
 *
 */
public class VertexComm 
{
	private Vector<Biclique> bn;
	private String kNum;
	private UndirectedSparseGraph<VertexObj, EdgeObj> graph;
	private BiGraph bg;

	public VertexComm(Vector<Biclique> b, String k, BiGraph bgg) 
	{
		bn = b;
		kNum = k;
		graph = createVertexComm(bn);
		bg = bgg;
	}
	
	private UndirectedSparseGraph<VertexObj, EdgeObj> createVertexComm(Vector<Biclique> bns)
	{
		UndirectedSparseGraph<VertexObj, EdgeObj> g = new UndirectedSparseGraph<VertexObj, EdgeObj>();
		
		for(int k = 0; k < bns.size(); k++)
		{
			for(int i = 0; i < bn.get(k).getBicliqueUpper().length; i++)
			{
				for(int j = 0; j < bn.get(k).getBicliqueLower().length; j++)
				{
					int a = bn.get(k).getBicliqueUpper()[i];
					int b = bn.get(k).getBicliqueLower()[j];
					
					IDNodeTypePair pa = new IDNodeTypePair(a, true);
					IDNodeTypePair pb = new IDNodeTypePair(b, false);
					
					VertexObj va = bg.getInfoFile().get(pa);
					VertexObj vb = bg.getInfoFile().get(pb);
					Pair<VertexObj> p = new Pair<VertexObj>(va, vb);
					EdgeObj e = new EdgeObj(va.getName(),
							vb.getName(), a, b);
					g.addEdge(e, p);
				}
			}
		}
		
		return g;
	}
	
	/**
	 * @return the list of bicliques
	 */
	public Vector<Biclique> getBicliques()
	{
		return bn;
	}
	
	/**
	 * @return the graph
	 */
	public UndirectedSparseGraph<VertexObj, EdgeObj> getVertexCommGraph()
	{
		return graph;
	}
	
	public String toString()
	{
		return kNum +" ("+ bn.size() +")";
	}

}
